image: gradle:jdk11

stages:
  - build
  - package
  # - deploy

cache:
  paths:
    - .gradle/wrapper
    - .gradle/caches
    - build/

build:
  stage: build
  script:
    - gradle wrap
    - ./gradlew clean
    - ./gradlew assemble
  artifacts:
    paths:
      - build/libs/*.jar
    expire_in: 1 week
  only:
    - main

docker-build:
  only:
    - main
  image: docker:latest
  stage: package
  services:
    - docker:dind
  before_script:
    - apk update && apk add git
    - echo $CI_REGISTRY_PASSWORD | docker login $DOCKER_REGISTRY -u $CI_REGISTRY_USER --password-stdin
    - TAG=$(git log -2 -1 --pretty=%h)
  script:
    - docker pull registry.gitlab.com/leo.kim1/osc-prj-backend:latest || true
    - docker image tag registry.gitlab.com/leo.kim1/osc-prj-backend:latest registry.gitlab.com/leo.kim1/osc-prj-backend:$TAG
    - docker build --tag registry.gitlab.com/leo.kim1/osc-prj-backend:latest .
    - docker push registry.gitlab.com/leo.kim1/osc-prj-backend:$TAG
    - docker push registry.gitlab.com/leo.kim1/osc-prj-backend:latest

#deploy-to-ubuntu:
#  stage: deploy
#  before_script:
#    - 'command -v ssh-agent > /dev/null || ( apt-get update -y && apt-get install openssh-client -y )'
#    - eval $(ssh-agent -s)
#    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
#    - mkdir -p ~/.ssh
#    - chmod 700 ~/.ssh
#    - echo "$SSH_KNOWN_HOST" >> ~/.ssh/known_hosts
#    - chmod 644 ~/.ssh/known_hosts
#
#  script:
#    - ssh -o StrictHostKeyChecking=no ubuntu@ec2-54-180-78-236.ap-northeast-2.compute.amazonaws.com -p 22 -i "$SSH_PRIVATE_KEY" 'rm -f /app/build/*.jar'
#    - ssh -o StrictHostKeyChecking=no ubuntu@ec2-54-180-78-236.ap-northeast-2.compute.amazonaws.com -p 22 -i "$SSH_PRIVATE_KEY" 'mkdir -p ~/app/build'
#    - scp -i "$SSH_PRIVATE_KEY" build/libs/*.jar ubuntu@ec2-54-180-78-236.ap-northeast-2.compute.amazonaws.com:~/app/build
#    - ssh -o StrictHostKeyChecking=no ubuntu@ec2-54-180-78-236.ap-northeast-2.compute.amazonaws.com -p 22 -i "$SSH_PRIVATE_KEY" '~/app/build/deploy.sh'
#  only:
#    - main
